#include <fstream>

#include "Runners.h"
/************************************************/
void GuidedLocalSearch::TestRun(Coloring &initial_ass) 
  /************************************************/
{
  InitializeRun();
  Coloring current_state(initial_ass);
  ColMove mv;
  float pen_delta;
  float pen_fit = current_state.fitness;
  unsigned int sidewalk=0; 

 
  for (Vertex i = 0; i < p_in->Vertices(); i++)
    {
      for (Color c = 0; c < current_state.CurrColors(); c++)
	{
	  if ( c !=  current_state.col[i])
	    if (current_state.PenDelta(i,c) != current_state.pen_delta[i][c])
	      {
		cerr<<"different! "<<i<<" "<<c<<" "<<current_state.PenDelta(i,c)
		    <<" "<<current_state.pen_delta[i][c]<<endl;
		exit(1);
	      }
	}
    }
 if (p_ctrl->lambda==0)
   {
  Vertex v; Color c;
  double sum = 0;
  for (int samples = 0; samples < 100; samples++)
    {
      v = rg->ran0N(p_in->Vertices()-1);
      do
	c = (Color)rg->ran0N((current_state.CurrColors()-1));
      while (c == current_state.col[v]);
      sum += abs(current_state.Delta(v,c));
    }
  float av_delta = sum / 100;
  p_ctrl->lambda = av_delta;
  cout<<"average delta -> "<< av_delta<<" "<<endl;
   }
  
  p_sm->print_data();
  //  current_state.print_pen_delta();

  //cout<<current_state<<endl;
  //------------------------------------------------------------
  ofstream os("tmp/gls-profile.dat");


  //     ostream eRRe("R --vanilla --silent");
  //       eRRe<<"rm(list=ls())\n";
  //       eRRe<<"X11()\n"<<endl;
     
  //       eRRe<<"viol <- c(%ld)\n",current.fitness;
  //   eRRe<<"iter <- c(%ld)\n",num_ofiteration;
  //------------------------------------------------------------

  //TabuList tl(p_in->Vertices(),current_state.CurrColors(),rg,p_ctrl);
  while ((current_state.fitness != 0) && !(MaxIterationExpired()) && 
	 (idle_iterations < max_idle_iteration) && p_ctrl->timeLeft())
    {
      sidewalk = 0;
      while ((current_state.fitness != 0) && !(MaxIterationExpired()) && 
	     (idle_iterations < max_idle_iteration) && p_ctrl->timeLeft())
	{
	 
	  UpdateIterationCounter();
	  pen_delta = MAX_FVALUE;
	  p_ne->BestMove(current_state,mv,pen_delta);

	  if (mv.type==0)
	    break;
	  if (pen_delta == 0)
	    {
	       sidewalk++; 
	      if (p_ctrl->sidewalks == 0 && sidewalk > (unsigned) 2*current_state.fitness)
		break;
	      else if (sidewalk > p_ctrl->sidewalks)
		break;   
	    }
	  else if (pen_delta < 0)
	    {
	      sidewalk = 0;
	    }
	  else 
	    break;
	  // cout<<"here"<<endl;
	  Coloring test_state(current_state);
	  if (!(test_state == current_state))
  	    {
  	      cerr<<"before"<<endl;
  	      exit(1);
  	    }
	  // tl.UpdateTabuList(current_state,mv,number_of_iterations);
	   cout<<mv<<endl;
	   p_ne->MakeMove(current_state,mv);
	  p_ne->MakeMove(test_state,mv);
	  p_sm->updateColoringData(test_state);
	   if (!(test_state == current_state))
  	    {
	      cerr<<"after move "<<endl;
  	      exit(1);
  	    }

	  if (current_state.fitness != 0)
	    current_state.feasible = false;
	  else
	    current_state.feasible = true;
	  if (current_state.fitness < initial_ass.fitness)
	    {
	      initial_ass = current_state;
	      p_ctrl->setCurrentCost(current_state.fitness,current_state.CurrColors(),number_of_iterations);
	      idle_iterations = 0;
	    }
	  idle_iterations++;

	  cout<<number_of_iterations<<"\t"<<current_state.fitness<<"\t"
	    <<(pen_fit+pen_delta)<<endl;
	  //------------------------------------------------------------
	  //       eRRe<<"viol <- c(viol,%ld)\n",current.fitness;
	  //        eRRe<<"iter <- c(iter,%ld)\n",num_ofiteration;
	  //------------------------------------------------------------
	}
      //os<<number_of_iterations<<"\t"<<0<<"\t"
      //	<<0<<endl;
  
      //------------------------------------------------------------
      /* if (par_iterations % 1 == 0) {*/
      //    eRRe<<"plot(iter,viol,type=\"l\",ylim=c(0,50),main=\"violations\")"<<endl;
      /*	 fprintf(eRRe,"rm=list(viol,iter)\n"); 
		 fprintf(eRRe,"viol <- c(%ld)\n",*violations);
		 fprintf(eRRe,"iter <- c(%ld)\n",*iteration);*/
      /*    }*/
      //------------------------------------------------------------
     


      cout<<"----------------------"<<endl;

      Coloring test_state(current_state);
      if (!(test_state == current_state))
	{
	  cerr<<"before"<<endl;
	  exit(1);
	}
      p_sm->update_data(current_state);
      p_sm->updateColoringData(test_state);
      if (!(test_state == current_state))
	{
	  cerr<<"after"<<endl;
	  exit(1);
	}
      cout<<"----------------------"<<endl;

      //p_sm->print_penalties();
      //      current_state.print_pen_delta();
      //p_sm->updateColoringData(current_state);
    }
  //------------------------------------------------------------
  p_sm->reinit_data();
  //p_sm->updateColoringData(current_state);
  os.close(); 

  /*fprintf(eRRe,"source(\"ps-plot-viol.R\")\n");*/
  //    eRRe.close();    
  /*    Fclose(violations_file); */
  //------------------------------------------------------------
  TerminateRun();
}  



/************************************************/
void GuidedLocalSearch::Run(Coloring &initial_ass) 
  /************************************************/
{
  //cout<<"here!"<<endl;
  InitializeRun();
  Coloring current_state(initial_ass);
  ColMove mv;
  float pen_delta;
  //  float pen_fit = current_state.fitness;
 unsigned int sidewalk=0; 

 
 if (p_ctrl->lambda==0)
   {
     Vertex v; Color c;
     double sum = 0;
     for (int samples = 0; samples < 100; samples++)
       {
	 v = rg->ran0N(p_in->Vertices()-1);
	 do
	   c = (Color)rg->ran0N((current_state.CurrColors()-1));
	 while (c == current_state.col[v]);
	 sum += abs(current_state.Delta(v,c));
       }
     float av_delta = sum / 100;
     p_ctrl->lambda  = av_delta;
   }
 
 //cout<<"average delta ->"<< av_delta<<" "<<endl;
 
  while ((current_state.fitness != 0) && !(MaxIterationExpired()) && 
	 (idle_iterations < max_idle_iteration) && p_ctrl->timeLeft())
    {
      sidewalk = 0;
      while ((current_state.fitness != 0) && !(MaxIterationExpired()) && 
	     (idle_iterations < max_idle_iteration) && p_ctrl->timeLeft())
	{
	  UpdateIterationCounter();
	  pen_delta = MAX_FVALUE;
	  p_ne->BestMove(current_state,mv,pen_delta);

	  if (mv.type==0)
	    break;
	  
	  if (pen_delta == 0)
	    {
	      sidewalk++; 
	      if (p_ctrl->sidewalks == 0 && sidewalk > (unsigned) 2*current_state.fitness)
		break;
	      else if (sidewalk > p_ctrl->sidewalks)
		break;   
	    }
	  else if (pen_delta < 0)
	    {
	      sidewalk = 0;
	    }
	  else 
	    break;
	  
	  p_ne->MakeMove(current_state,mv);

	  if (current_state.fitness != 0)
	    current_state.feasible = false;
	  else
	    current_state.feasible = true;
	  if (current_state.fitness < initial_ass.fitness)
	    {
	      initial_ass = current_state;
	      p_ctrl->setCurrentCost(current_state.fitness,current_state.CurrColors(),number_of_iterations);
	      idle_iterations = 0;
	    }
	  idle_iterations++;

	}
      p_sm->update_data(current_state);
      //p_sm->print_penalties();
      //current_state.print_pen_delta();
      //p_sm->updateColoringData(current_state);
  
    }

  p_sm->reinit_data();
  //p_sm->updateColoringData(current_state);

  TerminateRun();
}  



/************************************************/
void GuidedLocalSearchScaled::TestRun(Coloring &initial_ass) 
  /************************************************/
{
  InitializeRun();
  Coloring current_state(initial_ass);
  ColMove mv;
  float pen_delta;
  float pen_fit = current_state.fitness;
  unsigned int sidewalk=0; 
unsigned long calls_to_local_search = 0;
 
  for (Vertex i = 0; i < p_in->Vertices(); i++)
    {
      for (Color c = 0; c < current_state.CurrColors(); c++)
	{
	  if ( c !=  current_state.col[i])
	    if (current_state.PenDelta(i,c) != current_state.pen_delta[i][c])
	      {
		cerr<<"different! "<<i<<" "<<c<<" "<<current_state.PenDelta(i,c)
		    <<" "<<current_state.pen_delta[i][c]<<endl;
		exit(1);
	      }
	}
    }

   if (p_ctrl->lambda==0)
   {
  Vertex v; Color c;
  double sum = 0;
  for (int samples = 0; samples < 100; samples++)
    {
      v = rg->ran0N(p_in->Vertices()-1);
      do
	c = (Color)rg->ran0N((current_state.CurrColors()-1));
      while (c == current_state.col[v]);
      sum += abs(current_state.Delta(v,c));
    }
  float av_delta = sum / 100;
  p_ctrl->lambda = av_delta;
  cout<<"average delta -> "<< av_delta<<" "<<endl;
   }
   p_sm->reinit_data(); //<<<------???

  p_sm->print_data();
  //  current_state.print_pen_delta();

  //cout<<current_state<<endl;
  //------------------------------------------------------------
  ofstream os("tmp/gls-profile.dat");


  //     ostream eRRe("R --vanilla --silent");
  //       eRRe<<"rm(list=ls())\n";
  //       eRRe<<"X11()\n"<<endl;
     
  //       eRRe<<"viol <- c(%ld)\n",current.fitness;
  //   eRRe<<"iter <- c(%ld)\n",num_ofiteration;
  //------------------------------------------------------------

  //TabuList tl(p_in->Vertices(),current_state.CurrColors(),rg,p_ctrl);
  while ((current_state.fitness != 0) && !(MaxIterationExpired()) && 
	 (idle_iterations < max_idle_iteration) && p_ctrl->timeLeft())
    {
      sidewalk = 0;
	  calls_to_local_search++;
      while ((current_state.fitness != 0) && !(MaxIterationExpired()) && 
	     (idle_iterations < max_idle_iteration) && p_ctrl->timeLeft())
	{
	 
	  UpdateIterationCounter();
	  pen_delta = MAX_FVALUE;
	  p_ne->BestMove(current_state,mv,pen_delta);

	  if (mv.type==0)
	    break;
	  if (pen_delta == 0)
	    {
	      sidewalk++;
	       if (p_ctrl->sidewalks == 0 && sidewalk > (unsigned) 2*current_state.fitness)
		break;
	      else if (sidewalk > p_ctrl->sidewalks)
		break;   
	    }
	  else if (pen_delta < 0)
	    {
	      sidewalk = 0;
	    }
	  else 
	    break;
	  // cout<<"here"<<endl;
	  Coloring test_state(current_state);
	  if (!(test_state == current_state))
  	    {
  	      cerr<<"before"<<endl;
  	      exit(1);
  	    }
	  // tl.UpdateTabuList(current_state,mv,number_of_iterations);
	   cout<<mv<<endl;
	   p_ne->MakeMove(current_state,mv);
	  p_ne->MakeMove(test_state,mv);
	  p_sm->updateColoringData(test_state);
	   if (!(test_state == current_state))
  	    {
	      cerr<<"after move "<<endl;
  	      exit(1);
  	    }

	  if (current_state.fitness != 0)
	    current_state.feasible = false;
	  else
	    current_state.feasible = true;
	  if (current_state.fitness < initial_ass.fitness)
	    {
	      initial_ass = current_state;
	      p_ctrl->setCurrentCost(current_state.fitness,current_state.CurrColors(),number_of_iterations);
	      idle_iterations = 0;
	    }
	  idle_iterations++;

	  cout<<number_of_iterations<<"\t"<<current_state.fitness<<"\t"
	    <<(pen_fit+pen_delta)<<endl;
	  //------------------------------------------------------------
	  //       eRRe<<"viol <- c(viol,%ld)\n",current.fitness;
	  //        eRRe<<"iter <- c(iter,%ld)\n",num_ofiteration;
	  //------------------------------------------------------------
	}
      //os<<number_of_iterations<<"\t"<<0<<"\t"
      //	<<0<<endl;
  
      //------------------------------------------------------------
      /* if (par_iterations % 1 == 0) {*/
      //    eRRe<<"plot(iter,viol,type=\"l\",ylim=c(0,50),main=\"violations\")"<<endl;
      /*	 fprintf(eRRe,"rm=list(viol,iter)\n"); 
		 fprintf(eRRe,"viol <- c(%ld)\n",*violations);
		 fprintf(eRRe,"iter <- c(%ld)\n",*iteration);*/
      /*    }*/
      //------------------------------------------------------------
     


      cout<<"----------------------"<<endl;

      Coloring test_state(current_state);
      if (!(test_state == current_state))
	{
	  cerr<<"before"<<endl;
	  exit(1);
	}
      p_sm->update_data(current_state);
      p_sm->updateColoringData(test_state);
      if (!(test_state == current_state))
	{
	  cerr<<"after"<<endl;
	  exit(1);
	}
      cout<<"----------------------"<<endl;
      if ((calls_to_local_search % 200) == 0) //<<---------------------
			p_sm->scale_penalties();

      //p_sm->print_penalties();
      //      current_state.print_pen_delta();
      //p_sm->updateColoringData(current_state);
    }
  //------------------------------------------------------------
  //p_sm->reinit_data();
  //p_sm->updateColoringData(current_state);
  os.close(); 

  /*fprintf(eRRe,"source(\"ps-plot-viol.R\")\n");*/
  //    eRRe.close();    
  /*    Fclose(violations_file); */
  //------------------------------------------------------------
  TerminateRun();
}  



/************************************************/
void GuidedLocalSearchScaled::Run(Coloring &initial_ass) 
  /************************************************/
{
  //cout<<"here!"<<endl;
  InitializeRun();
  Coloring current_state(initial_ass);
  ColMove mv;
  float pen_delta;
  //  float pen_fit = current_state.fitness;
 unsigned int sidewalk=0; 
 unsigned long calls_to_local_search = 0;

if (p_ctrl->lambda==0)
   {
 Vertex v; Color c;
  double sum = 0;
  for (int samples = 0; samples < 100; samples++)
    {
      v = rg->ran0N(p_in->Vertices()-1);
      do
	c = (Color)rg->ran0N((current_state.CurrColors()-1));
      while (c == current_state.col[v]);
      sum += abs(current_state.Delta(v,c));
    }
  float av_delta = sum / 100;
  p_ctrl->lambda  = av_delta;
   }
//cout<<"average delta ->"<< av_delta<<" "<<endl;
	p_sm->reinit_data(); //<<<------???
	//cout<<p_ctrl->lambda<<endl;
  while ((current_state.fitness != 0) && !(MaxIterationExpired()) && 
	 (idle_iterations < max_idle_iteration) && p_ctrl->timeLeft())
    {
      sidewalk = 0;
     calls_to_local_search++;
	   while ((current_state.fitness != 0) && !(MaxIterationExpired()) && 
	     (idle_iterations < max_idle_iteration) && p_ctrl->timeLeft())
	{
	  UpdateIterationCounter();
	  pen_delta = MAX_FVALUE;
	  p_ne->BestMove(current_state,mv,pen_delta);

	  if (mv.type==0)
	    break;
	  
	  if (pen_delta == 0)
	    {
	        sidewalk++; 
	      if (p_ctrl->sidewalks == 0 && sidewalk > (unsigned) 2*current_state.fitness)
		break;
	      else if (sidewalk > p_ctrl->sidewalks)
		break;   
	    }
	  else if (pen_delta < 0)
	    {
	      sidewalk = 0;
	    }
	  else 
	    break;
	  
	  p_ne->MakeMove(current_state,mv);

	  if (current_state.fitness != 0)
	    current_state.feasible = false;
	  else
	    current_state.feasible = true;
	  if (current_state.fitness < initial_ass.fitness)
	    {
	      initial_ass = current_state;
	      p_ctrl->setCurrentCost(current_state.fitness,current_state.CurrColors(),number_of_iterations);
	      idle_iterations = 0;
	    }
	  idle_iterations++;

	}
	   p_sm->update_data(current_state);
      //p_sm->print_penalties();
      //current_state.print_pen_delta();
      //p_sm->updateColoringData(current_state);
		if ((calls_to_local_search % 200) == 0) //<<---------------------
			p_sm->scale_penalties();
    }

  
  //p_sm->updateColoringData(current_state);

  TerminateRun();
}  





