#include "Solution.h"

//------------------------------------------------------------

bool nextNodeToColor(Vertex &node,map<Vertex, Color > &toColor,
		     vector<VertexSet> &Dsat,vector<unsigned int> &degree)
{
  int max_bis=-1,max=-1,temp=0;
  Vertex node_bis = INT_MAX;
   //dsat[v]= dg[v] if N(v) is not colored, otherwise dsat(v)=card(nodes colored in N(v))
  map<Vertex, Color>::iterator pt;
   for(pt=toColor.begin(); pt!=toColor.end();pt++)
     {
       Vertex i = (*pt).first;
       if (Dsat[i].size()!=degree[i])
	 {
	   temp = Dsat[i].size();
	   if  (max < temp)
	       {
		 max=temp;
		 node=i;
	       }
	   if  ((temp==max) && (degree[i]>degree[node]))
	     { //second criterion
	       max = temp;
	       node = i;
	     }			
	 }
       else 
	 {
	   if (max_bis < (int) degree[i])
	     {
	       max_bis = (int) degree[i];
	       node_bis = i; 
	     }
	 }
     }
   if (max >= 0)
     {
       return true;
     }
   else if (max_bis >= 0)
     {
       node = node_bis;
       return true;
     }
   else 
       return false;
}


Vertex ColoringManager::perturbate_seq(Coloring &ass,Color to_remove, 
				     TabuList &tl, long int iter)
{
  map< Vertex, Color > to_color;
  vector<Vertex> to_color_order;
  vector<Color> colors_used;
  vector<VertexSet> adj_colors;//.resize(p_in->Vertices());
  Color k = ass.CurrColors();
  Color col; 
  Color i = 0;

  VertexSet::iterator pt,pt_set;

  vector<Vertex>::iterator node;
    
  adj_colors.resize(p_in->Vertices());
  while (i < to_remove)
    {
      i++;
      do {
	col = rg->ran0N(k-1);
      } while (find(colors_used.begin(),colors_used.end(),col)!=colors_used.end());
      colors_used.push_back(col);
      for (pt_set = ass.partitions[col].begin(); pt_set != ass.partitions[col].end(); 
	   pt_set++)
	{
	  to_color.insert(pair<Vertex, Color>(*pt_set,col));
	  to_color_order.push_back(*pt_set);
	  ass.col[*pt_set] = -1;
	  tl.IterTabu(*pt_set,col) = rg->ran0N(10) 
	    + (int)(p_ctrl->alpha * 2*ass.fitness) + iter;
	}
      ass.partitions[col].clear(); 
    }
  
  Vertex moved = to_color.size();
  Vertex h;
  for(Vertex i = 0; i < to_color_order.size(); i++) { 
    /* scramble the list of veritces to obtain a random order*/
    Vertex j = (Vertex) rg->ran0N(to_color_order.size()-1);
    h = to_color_order[i];
    to_color_order[i] = to_color_order[j];
    to_color_order[j] = h;
  }
  
  
  for (node = to_color_order.begin(); node!=to_color_order.end(); node++)
    {

      bool assigned = false;
      Color l=0;
      while (l<k)
	 {
	   assigned = false;
	   pt = p_in->adjacency_set[*node].begin();
	   while (pt != p_in->adjacency_set[*node].end())
	     {
	       if (ass.col[*pt]==l || l==to_color.find(*node)->second)
		 {
		   assigned = true;
		   break;
		 }
	       pt++;
	     }
	   if (!assigned)
	     {
	       ass.col[*node] = l;
	       break;
	     }
	   else 
	     l++;
	 }
      if (ass.col[*node]<0)
	{
	  ass.col[*node] = rg->ran0N(k-1);
	  //assert(ass.col[*node]>=0 && ass.col[*node]<num_col);
	}
    }
  updateColoringData(ass);
  return moved;
}


Vertex ColoringManager::perturbate_dsat(Coloring &ass,Color to_remove, 
				      TabuList &tl, long int iter)
{
  map< Vertex, Color > to_color;

  vector<Color> colors_used;
  vector<VertexSet> adj_colors;//.resize(p_in->Vertices());
  Color k = ass.CurrColors();
  Color col; Vertex node;
  Color i = 0;

  map<Vertex, Color>::iterator pt_pair,which;
  VertexSet::iterator pt_set;
  VertexSet::iterator pt_inner;

    
  adj_colors.resize(p_in->Vertices());
  while (i < to_remove)
    {
      i++;
      do {
	col = rg->ran0N(k-1);
      } while (find(colors_used.begin(),colors_used.end(),col)!=colors_used.end());
      colors_used.push_back(col);
      for (pt_set = ass.partitions[col].begin(); pt_set != ass.partitions[col].end(); 
	   pt_set++)
	{
	  to_color.insert(pair<Vertex, Color>(*pt_set,col));
	  ass.col[*pt_set] = -1;
	   tl.IterTabu(*pt_set,col) = rg->ran0N(10) 
	     + (int)(p_ctrl->alpha * ass.fitness) + iter;
	}
      ass.partitions[col].clear(); 
    }
  Vertex moved = to_color.size();
  node = p_in->Vertices();
  int max = -1;

  for (pt_pair = to_color.begin(); pt_pair!=to_color.end(); pt_pair++)
    {
      for (pt_inner = p_in->adjacency_set[pt_pair->first].begin();
	   pt_inner!=p_in->adjacency_set[pt_pair->first].end(); pt_inner++)
	{
	  if (ass.col[*pt_inner] >= 0)
	    adj_colors[pt_pair->first].insert(ass.col[*pt_inner]);
	}
      if (max <(int) adj_colors[pt_pair->first].size())
	{
	  node = pt_pair->first;
	  max = adj_colors[node].size();
	}

    }

  //assert(node < p_in->Vertices());
  
  do {
    which = to_color.find(node);
    if ((Color) adj_colors[node].size() < k) 
      {
	col = 0;
	while ((col < k) && (adj_colors[node].find(col) != adj_colors[node].end()) 
	       && col==(*which).second)
	  col++;
      }
    else
      do {
	col = rg->ran0N(k-1);
      } while (col == (*which).second);
    
    ass.col[node] = col;
    to_color.erase(node); 
    
    for (pt_pair = to_color.begin(); pt_pair != to_color.end(); pt_pair++)
      {
	if (p_in->Edge(pt_pair->first,node))
	  adj_colors[pt_pair->first].insert(col);
      }
  } while (nextNodeToColor(node,to_color,adj_colors,p_in->degree));
  
  updateColoringData(ass);
  return moved;
}
 



Vertex ColoringManager::perturbate_best_moves(Coloring &ass,Color to_remove, 
				      TabuList &tl, long int iter)
{
  map< Vertex, Color > to_color;

  vector<Color> colors_used;
  vector<VertexSet> adj_colors;//.resize(p_in->Vertices());
  Color k = ass.CurrColors();
  Color col; Vertex node;
  Color i = 0;

  map<Vertex, Color>::iterator pt_pair,which;
  VertexSet::iterator pt_set;
  VertexSet::iterator pt_inner;

    
  adj_colors.resize(p_in->Vertices());
  
  
  while (i < to_remove)
    {
      i++;
      do {
	col = rg->ran0N(k-1);
      } while (find(colors_used.begin(),colors_used.end(),col)!=colors_used.end());
      colors_used.push_back(col);
      for (pt_set = ass.partitions[col].begin(); pt_set != ass.partitions[col].end(); 
	   pt_set++)
	{
	  to_color.insert(pair<Vertex, Color>(*pt_set,col));
	  ass.col[*pt_set] = -1;
	   tl.IterTabu(*pt_set,col) = rg->ran0N(10) 
	     + (int)(p_ctrl->alpha * ass.fitness) + iter;
	}
      ass.partitions[col].clear(); 
    }
  Vertex moved = to_color.size();
  node = p_in->Vertices();
  int max = -1;

  for (pt_pair = to_color.begin(); pt_pair!=to_color.end(); pt_pair++)
    {
      for (pt_inner = p_in->adjacency_set[pt_pair->first].begin();
	   pt_inner!=p_in->adjacency_set[pt_pair->first].end(); pt_inner++)
	{
	  if (ass.col[*pt_inner] >= 0)
	    adj_colors[pt_pair->first].insert(ass.col[*pt_inner]);
	}
      if (max <(int) adj_colors[pt_pair->first].size())
	{
	  node = pt_pair->first;
	  max = adj_colors[node].size();
	}

    }

  assert(node < p_in->Vertices());
  
  do {
    which = to_color.find(node);
    if ((Color) adj_colors[node].size() < k) 
      {
	col = 0;
	while ((col < k) && (adj_colors[node].find(col) != adj_colors[node].end()) 
	       && col==(*which).second)
	  col++;
      }
    else
      do {
	col = rg->ran0N(k-1);
      } while (col == (*which).second);
    
    ass.col[node] = col;
    to_color.erase(node); 
    
    for (pt_pair = to_color.begin(); pt_pair != to_color.end(); pt_pair++)
      {
	if (p_in->Edge(pt_pair->first,node))
	  adj_colors[pt_pair->first].insert(col);
      }
  } while (nextNodeToColor(node,to_color,adj_colors,p_in->degree));
  
  updateColoringData(ass);
  return moved;
}


void ColoringManager::uncolor(Coloring &ass, Vertex var, Color level)
{
  if ( level == 0 ) return;
  VertexSet::const_iterator pa;
  
  for (pa = p_in->adjacency_set[var].begin(); pa != p_in->adjacency_set[var].end(); pa++)
    {
      ass.col[*pa] = -1;
      uncolor(ass, *pa, level-1);
    } 
  return;
}


void ColoringManager::color(Coloring &ass, Vertex var, Color level, Vertex &changed)
{
  if ( level == 0 ) return;
  VertexSet::const_iterator pa;
  for (pa = p_in->adjacency_set[var].begin(); pa != p_in->adjacency_set[var].end(); pa++)
    {
      if ( ass.col[*pa] < 0)
	{
	  ass.col[*pa] = rg->ran0N(ass.CurrColors()-1);
	  changed++;
	}
      color(ass, *pa, level-1, changed);
    } 
}


Vertex ColoringManager::perturbate_adj(Coloring &ass,Color level, 
				      TabuList &tl, long int iter)
{
  Color k = ass.CurrColors();
  Vertex moved = 0;

  
  VertexSet::iterator pt; 
  
  for (pt = ass.conflicts_set.begin(); pt != ass.conflicts_set.end(); pt++)
    {
      ass.col[*pt]=-1;
      uncolor(ass,*pt,level);
    }

  for (pt = ass.conflicts_set.begin(); pt != ass.conflicts_set.end(); pt++)
    {
      if (ass.col[*pt]<0)
	{
	  ass.col[*pt]= rg->ran0N(k-1);
	  moved++;
	}
      color(ass,*pt,level,moved);
    } 
  updateColoringData(ass);
  return moved;
}
 








